// Generated by gencpp from file ld_msgs/ld_mobileye_traffic_sign.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_MOBILEYE_TRAFFIC_SIGN_H
#define LD_MSGS_MESSAGE_LD_MOBILEYE_TRAFFIC_SIGN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_mobileye_traffic_sign_
{
  typedef ld_mobileye_traffic_sign_<ContainerAllocator> Type;

  ld_mobileye_traffic_sign_()
    : header()
    , address()
    , sign_type(0)
    , text_sign()
    , supplementary_sign_type(0)
    , text_supplementary_sign_type()
    , position_x(0.0)
    , position_y(0.0)
    , position_z(0.0)
    , filter_type(0)  {
    }
  ld_mobileye_traffic_sign_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , address(_alloc)
    , sign_type(0)
    , text_sign(_alloc)
    , supplementary_sign_type(0)
    , text_supplementary_sign_type(_alloc)
    , position_x(0.0)
    , position_y(0.0)
    , position_z(0.0)
    , filter_type(0)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _address_type;
  _address_type address;

   typedef uint8_t _sign_type_type;
  _sign_type_type sign_type;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _text_sign_type;
  _text_sign_type text_sign;

   typedef uint8_t _supplementary_sign_type_type;
  _supplementary_sign_type_type supplementary_sign_type;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _text_supplementary_sign_type_type;
  _text_supplementary_sign_type_type text_supplementary_sign_type;

   typedef double _position_x_type;
  _position_x_type position_x;

   typedef double _position_y_type;
  _position_y_type position_y;

   typedef double _position_z_type;
  _position_z_type position_z;

   typedef uint8_t _filter_type_type;
  _filter_type_type filter_type;





  typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> const> ConstPtr;

}; // struct ld_mobileye_traffic_sign_

typedef ::ld_msgs::ld_mobileye_traffic_sign_<std::allocator<void> > ld_mobileye_traffic_sign;

typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_traffic_sign > ld_mobileye_traffic_signPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_traffic_sign const> ld_mobileye_traffic_signConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/xiaotongliu/CANMessageParser/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
{
  static const char* value()
  {
    return "a1cbcc63da85176f5b338b9210cbf63e";
  }

  static const char* value(const ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xa1cbcc63da85176fULL;
  static const uint64_t static_value2 = 0x5b338b9210cbf63eULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_mobileye_traffic_sign";
  }

  static const char* value(const ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# file Protocol_ExtLogData2_2.25.pdf\n\
# Address 0x720,0x721,...,0x726\n\
# also see ME_Standard_CAN_Output_Protocol_Rev2.7, capitel 6\n\
\n\
std_msgs/Header header\n\
string address\n\
uint8 sign_type\n\
string text_sign\n\
uint8 supplementary_sign_type\n\
string text_supplementary_sign_type\n\
float64 position_x\n\
float64 position_y\n\
float64 position_z\n\
uint8 filter_type\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.address);
      stream.next(m.sign_type);
      stream.next(m.text_sign);
      stream.next(m.supplementary_sign_type);
      stream.next(m.text_supplementary_sign_type);
      stream.next(m.position_x);
      stream.next(m.position_y);
      stream.next(m.position_z);
      stream.next(m.filter_type);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_mobileye_traffic_sign_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_mobileye_traffic_sign_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "address: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.address);
    s << indent << "sign_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.sign_type);
    s << indent << "text_sign: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.text_sign);
    s << indent << "supplementary_sign_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.supplementary_sign_type);
    s << indent << "text_supplementary_sign_type: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.text_supplementary_sign_type);
    s << indent << "position_x: ";
    Printer<double>::stream(s, indent + "  ", v.position_x);
    s << indent << "position_y: ";
    Printer<double>::stream(s, indent + "  ", v.position_y);
    s << indent << "position_z: ";
    Printer<double>::stream(s, indent + "  ", v.position_z);
    s << indent << "filter_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.filter_type);
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_MOBILEYE_TRAFFIC_SIGN_H
